<?php
/*
 *      help_dossierdyn.php
 *
 *      Copyright 2007 Jonas Fourquier <http://jonas.tuxfamily.org>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */


require dirname(__FILE__).'/../../inc/prepend.php';
$auth->check(9);
l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'-utf8/popup');


echo '
<head>
  <title>'.__('Dossier dynamique').'</title>
  <meta name="GENERATOR" content="Quanta Plus">
  <meta name="AUTHOR" content="Jonas Fourquier">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <style type="text/css">
    @import "../../style/default.css";
    @import "style.css";
    pre {
        margin-top: .1em;
        margin-bottom: .2em;
    }
  </style>
  <link rel="icon" type="image/png" href="icone.png" />
</head>
<body class="popup" style="margin-top:15px; margin-bottom: 0px">
<div id="main"><div id="content" style="margin-right: 15px; margin-top: -10px">

<h2>'.__('Dossier dynamique').'</h2>


<p>'.__('Il est possible de faire des dossiers qui changent de nom en fonction de la date ou de l\'utilisateur loggué').'.</p>

<ul>
    <li><code>%auteur%</code> : '.__('id de l\'utilisateur').' (<code>'.$_GET['auteur'].'</code>)</li>
    <li><code>%d%</code> : '.__('jours du mois en 2 chiffres').'  (<code>'.date("d").'</code>)</li>
    <li><code>%m%</code> : '.__('mois en 2 chiffres').'  (<code>'.date("m").'</code>)</li>
    <li><code>%y%</code> : '.__('année en 2 chiffres').'  (<code>'.date("y").'</code>)</li>
    <li><code>%Y%</code> : '.__('année en 4 chiffres').'  (<code>'.date("Y").'</code>)</li>
</ul>

'.__('Exemple').' :
<pre> images/%auteur%/%Y%-%m%-%d%/</pre>
'.__('Créera le dossier').' :
<pre> images/'.$_GET['auteur'].'/'.date("Y").'-'.date("m").'-'.date("d").'/</pre>

<p align="center"><a href="#" onclick="window.close(); return; false">['.__('fermer').']</a></p>

</div></div>
</body>';
?>
